Bug 143499 - Slow response in document with many headings
Summary: Slow response in document with many headings
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
7.0.0.3 release
Hardware: All Linux (All)
: medium normal
Assignee: Caolán McNamara
URL:
Whiteboard: target:7.3.0 target:7.2.1
Keywords: bibisected, perf, regression
Depends on:
Blocks:
 
Reported: 2021-07-22 15:44 UTC by David
Modified: 2021-08-08 20:53 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments
document with many headings (9.95 KB, application/vnd.oasis.opendocument.text)
2021-07-22 15:44 UTC, David
Details

Note You need to log in before you can comment on or make changes to this bug.
Description David 2021-07-22 15:44:19 UTC
Created attachment 173775 [details]
document with many headings

This bug seems to have begun with 7.x and continues with 7.3 alpha.  There is a severe lag when typing in an outline heading when there are many headings and the sidebar and/or navigator is enabled.  Version 6.x does not experience this lag.  Bug is probably related to bug 143268.
Comment 1 BogdanB 2021-07-22 21:17:14 UTC
Confirm severe lag when typeing in any Heading.

Version: 7.3.0.0.alpha0+ / LibreOffice Community
Build ID: c6695a4aabeaae99174b7658f2b813788ecff7f0
CPU threads: 4; OS: Linux 5.8; UI render: default; VCL: gtk3
Locale: ro-RO (ro_RO.UTF-8); UI: en-US
Calc: threaded

Also in
Version: 7.1.5.2 / LibreOffice Community
Build ID: 85f04e9f809797b8199d13c421bd8a2b025d52b5
CPU threads: 4; OS: Linux 5.8; UI render: default; VCL: gtk3
Locale: ro-RO (ro_RO.UTF-8); UI: en-US
Calc: threaded
Comment 2 Kevin Suo 2021-07-26 06:23:06 UTC
Bibisected to range
16b0bbb671a8080655e27542e576478486810404..002d1152dc418f7d624409e76cd9d4ac0b42c7f8

whereas the following one is suspicious:

author Caolán McNamara 2020-02-28 11:13:12 +0000
committer Caolán McNamara 2020-03-24 11:00:50 +0100
commit	5a2c0ab29719ac914d30d8789c0e386541702cbf (patch)
weld writer navigator

Adding Caolán to cc: would you please take a look? Thank you.
Comment 3 Commit Notification 2021-08-03 20:08:53 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/58f0eb6ddba26705535d07b07a17f5cf141cf3da

Related: tdf#143499 lookup id just once

It will be available in 7.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 4 Commit Notification 2021-08-04 09:59:48 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/36efb384a66b6dd645e0ae80fd7df68370a9dc8b

tdf#143499 don't search entire tree looking for insertion point

It will be available in 7.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 5 Caolán McNamara 2021-08-04 10:05:58 UTC
AFAIKT that gives the same results, but far faster. Backport to just 7-2 for now in gerrit
Comment 6 BogdanB 2021-08-06 07:39:18 UTC
Very fast now.
Thanks for fixing this bug.

Version: 7.3.0.0.alpha0+ / LibreOffice Community
Build ID: 36efb384a66b6dd645e0ae80fd7df68370a9dc8b
CPU threads: 4; OS: Linux 5.11; UI render: default; VCL: gtk3
Locale: ro-RO (ro_RO.UTF-8); UI: en-US
Calc: threaded
Comment 7 David 2021-08-06 11:06:53 UTC
Just tested from the nightly build and it is fixed!  Is there any possibility that a similar fix would resolve bug 143268, which is for the same problem with tables?
Comment 8 Commit Notification 2021-08-08 20:53:23 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "libreoffice-7-2":

https://git.libreoffice.org/core/commit/3f43dc55dba1af61cb587d0a81e1f920c129daaa

tdf#143499 don't search entire tree looking for insertion point

It will be available in 7.2.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.